Hello Codeforces! I got some interesting tricks to share with you.

### 1. a_i := (a_i + x)%mod Range Updates, Max Range Queries

Apply usual range addition, but after each update run the following code:

```
void normalize(int l, int r) {
while(getmax(l, r).max >= mod) {
set(getmax(l, r).pos, getmax(l, r).max%mod);
}
}
```

What is the complexity of this code? We all know that each time we %%=mod$ number which is $$$\geqslant mod$$$ it halves, that means each number will be updated $$$O(log)$$$ times, we will perform $$$O(n\cdot\log{n}\cdot\log{a})$$$ operations in total. So each update will be $$$O(\log{n}\cdot\log{a})$$$ amortized!

### 2. $$$O(\log^2{\log{n}})$$$ Segment Tree

Segment tree queries are queries on path. Instead of doing them in the usual brute force-ish way we can use HLD! Since maximum path length is $$$2\cdot\log{n}$$$, thus operations are now operations are $$$O(\log^2{\log{n}})$$$, which is better than $$$O(\log{n})$$$.

### 3. Faster Dinic's

We know that after $$$i$$$ operations Dinic's algo finds flow which is at least $$$\frac{i}{i+1}\cdot{maxflow}$$$. In some problems we just want to check whether flow is at least $$$x$$$. Using the fact above we can run *one iteration* of the algorigthm which will get us $$$\frac{1}{2}$$$ of maxflow and multiply that by two. Now just compare $$$x$$$ and maxflow.

### 4. Linear FFT

Usually, we use roots of unity ($$$e^{\frac{\tau\cdot t}{n} \cdot i}$$$) or primitive roots (for ntt). But why would we limit ourselves to those?

Instead of roots of unity, we can choose roots of something else, that looks complex enough. This, for example:

$$${e^{\sqrt[x]{6 \cdot \pi ^ 2 \cdot \prod_{1 \leqslant i \leqslant 10} {(x - i \cdot x^{\frac{1}{i}})}} + i\cdot\frac{\pi}{2}}} = i$$$

Let's choose a few roots of this thing which we'll use for FFT. We can notice that $$$(-1)^{\frac{i}{2\cdot i - 2}}, 1 \leqslant i \leqslant 10$$$ work. So using them we have $$$O(10\cdot n) = O(n)$$$ FFT!

### 5. Linear Interpolation(Actually Point Evaluation Without Finding The Polynomial)

We can interpolate in linear time if given x coordinates of given points are n consequential integers (check out 622F editorial for details). We can use this approach to perform general interpolation in $$$O(n)$$$. Let $$$f$$$ be the polynomial interpolated, n be the number of points given, $$$v$$$ be the x value in which we want to evaluate $$$f$$$, $$$x$$$ be x coordinates, and $$$y$$$ be y coordinates of given points. Let's introduce a new polynomial $$$g$$$, such that $$$g(i) = x_i, 0 \leqslant i \lt n$$$. We can solve $$$g(x) = v$$$ easily using HS math in $$$O(n)$$$ time. Now, let's interpolate $$$h(x) = f(g(x))$$$ instead of $$$f(x)$$$. We just evaluate $$$h(g^{-1}(x))$$$ since input of $$$h$$$ is n consequential integers we can do it in linear time. Easy as that!

Thanks for reading, I hope your rating will skyrocket after applying those in contest! If you have any questions feel free to leave commments or DM me(kostia244) or AryaPawn